
// PIC16F877A Configuration Bit Settings

// 'C' source line config statements

// CONFIG
#pragma config FOSC = HS        // Oscillator Selection bits (HS oscillator)
#pragma config WDTE = OFF       // Watchdog Timer Enable bit (WDT disabled)
#pragma config PWRTE = OFF      // Power-up Timer Enable bit (PWRT disabled)
#pragma config BOREN = ON       // Brown-out Reset Enable bit (BOR enabled)
#pragma config LVP = OFF         // Low-Voltage (Single-Supply) In-Circuit Serial Programming Enable bit (RB3/PGM pin has PGM function; low-voltage programming enabled)
#pragma config CPD = OFF        // Flash Program Memory Write Enable bits (Write protection off; all program memory may be written to by EECON control)
#pragma config CP = OFF  // Data EEPROM Memory Code Protection bit (Data EEPROM code protection off)
#pragma config WRT = OFF               // Flash Program Memory Code Protection bit (Code protection off)

// #pragma config statements should precede project file includes.
// Use project enums instead of #define for ON and OFF.

#include <xc.h>



#define TXEN_hbit   RC6
#define MAX_485_PIN RD4     //  to be decided.

#define HEALTH_LED RC2

#define	SET_HI_lcden_hbit	PORTDbits.RD2=1;
#define	SET_LO_lcden_hbit	PORTDbits.RD2=0;

#define	SET_HI_lcdrs_hbit	PORTCbits.RC5=1;
#define	SET_LO_lcdrs_hbit	PORTCbits.RC5=0;

#define	SET_HI_lcdrw_hbit   PORTDbits.RD3=0;

#define	LCD_PORT            PORTB
void delay_ms(unsigned int ms);

//==================LCD prototype ==============================================
void wr_lcdport(unsigned char temp);
void lcd_smalldelay(void);
void wr_lcdbyte(unsigned char lcdbyte);
void lcd_wrdelay(void);
void init_lcd(void);
void lcd_com_wr(unsigned char command);
void lcd_data_wr(unsigned char dataa);
void lcd_comdata_wr(unsigned char command,unsigned char dta);
void lcd_arraywr_rom(unsigned char lcd_startaddr, unsigned char* array_start_ptr);
void lcd_arraywr_ram(unsigned char lcd_startaddr,unsigned char * array_start_ptr, unsigned char counts);
void lcd_clear( void);
//void lcd_curblink_on(void);
void hex2disp(unsigned char lcd_addr,unsigned char val);
void display_long(unsigned char lcdadr,unsigned int longval);





//------------------------------MODBUS------------------------------------------


#define LOWBYTE     0
#define HIGHBYTE    1

void decode_mbus_frame(void);
void function_error(unsigned int func);
void address_error(unsigned int func);
void send_readonly_byte(unsigned int len);
void FillNSend_Echo_Frame(void);
void send_to_master(void);
unsigned int CRC_16(unsigned char *ptr,unsigned char cnts);

unsigned char calculate_parity(unsigned char val);
void send_continuous(unsigned int length, unsigned int address);
void write_single_holding(unsigned int length, unsigned int address);



//union int_char
//{
//	unsigned int int_val;
//	unsigned char char_val[2];
//};



//v51958541  dtdc